--include "vocab.lua"


function chooseRandom(tbl)
	local l=#tbl.entries
	return math.random(l)
end

function randNextRange(n)
	return math.random(0, n-1)
end


punct = {["."]=true, [","]=true, [";"]=true, ["!"]=true, ["?"]=true}

function randomCaps(str)
	local r = not randNextRange(2)
	local c;
	local out = ""
	
	for i=1, #str do
		c = str:sub(i,i);
		if punct[c] and randNextRange(3) == 1 then
			r = not r;
		end
		
		if r then c=c:upper() end 
		out = out .. c
	end
	
	return out
end

function goNikky(outText, tbl)
	local i, newChar
	local t
	capitalize = false
	--print(tbl.name)
	local ttype = tbl.type

	if ttype == "SEQUENCE" then
		-- Execute template entries in sequential order
		for i=1, #tbl.entries do
			if (randNextRange(128) <= tbl.entries[i].probability) then
				capitalize = tbl.entries[i].capitalize or capitalize
				--print(tbl.name, tbl.entries[i].capitalize)
				outText = goNikky(outText, tbl.entries[i].target)
			end
		end
		
	elseif ttype == "RANDOM" then
		-- Randomly select an entry from template pointed to
		i = chooseRandom(tbl)
		capitalize = tbl.entries[i].capitalize or capitalize
		outText = goNikky(outText, tbl.entries[i].target)
		
	elseif ttype == "VOCABULARY" then
		-- Randomly select word from list and add it
		i = chooseRandom(tbl)
		t = tbl.entries[i].target
		newChar = #outText
		
		outText = outText .. t
		if (capitalize) then
			outText = outText:substr(1, newChar-1) .. outText:substr(newChar, newChar):upper() .. outText:substr(newChar+1, -1)
		end
		
		capitalize = false
		if randNextRange(256) == 1 then
			-- ALL CAPS DAY
			outText = randomCaps(outText)
		end
	end
	
	return outText
end
